%This program evaluates the analytical first and second (if approx=2) derivatives of f numerically. The parameters and steady state values of the arguments of the function f are assumed to be in the workspace. Also, the order of approximation must be in the workspace.
%
%(c) Stephanie Schmitt-Grohe and Martin Uribe
%Date July 17, 2001
%Changed on September 25, 2001 to replace subs with eval and make it no longer a function.


nd.f = ad.f(R0,R1,Rc1,bet,c1,c2,e1,e2,g1,g2,gst,nu,phi,pi1,pi2,pist,psi1,psi2,rhog,rhor,rhoz,tau,y1,y2,ys1,z1,z2);

nd.fx = ad.fx(g1,psi2,rhog,rhor,rhoz);

nd.fxp = ad.fxp(R1,c1,c2,pi2,tau,z2);

nd.fy = ad.fy(R1,bet,c1,c2,gst,nu,phi,pi1,pi2,pist,psi1,psi2,rhor,tau,y1,y2,z2);

nd.fyp = ad.fyp(R1,bet,c1,c2,pi2,tau,y1,y2,z2);

% If only a first-order approximation is desired, set all second derivatives equal to zero
if approx ==1
    nd.fypyp=0; nd.ypy=0; nd.ypxp=0; nd.ypx=0; nd.yyp=0; nd.yy=0; nd.yxp=0; nd.yx=0; nd.xpyp=0; nd.xpy=0; nd.xpxp=0; nd.xpx=0; nd.xyp=0; nd.xy=0; nd.xxp=0; nd.xx=0;
else

nd.fypyp = ad.fypyp(R1,bet,c1,c2,pi2,tau,y1,y2,z2);

nd.fypy = ad.fypy(R1,bet,c1,c2,pi2,tau,y1,y2,z2);

nd.fypxp = ad.fypxp(R1,c1,c2,pi2,tau,z2);

nd.fypx = ad.fypx();
  
nd.fyyp = ad.fyyp(R1,bet,c1,c2,pi2,tau,y1,y2,z2);

nd.fyy = ad.fyy(R1,bet,c1,c2,gst,nu,phi,pi1,pi2,pist,tau,y1,y2,z2);

nd.fyxp = ad.fyxp(R1,c1,c2,pi2,tau,z2);

nd.fyx = ad.fyx(); 

nd.fxpyp = ad.fxpyp(R1,c1,c2,pi2,tau,z2);

nd.fxpy = ad.fxpy(R1,c1,c2,pi2,tau,z2);

nd.fxpxp = ad.fxpxp(R1,c1,c2,pi2,tau,z2);
  
nd.fxpx = ad.fxpx();
    
nd.fxyp = ad.fxyp();  
      
nd.fxy = ad.fxy();

nd.fxxp = ad.fxxp();

nd.fxx = ad.fxx(g1);

end 